VERSION 5.00
Begin VB.Form frmDebugData 
   Caption         =   "Debug Data"
   ClientHeight    =   2496
   ClientLeft      =   48
   ClientTop       =   336
   ClientWidth     =   3744
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2496
   ScaleWidth      =   3744
   StartUpPosition =   2  'CenterScreen
   Begin VB.Frame frDebugData 
      Caption         =   "DataType"
      Height          =   2172
      Left            =   2040
      TabIndex        =   5
      Top             =   120
      Width           =   1452
      Begin VB.OptionButton obDebugData 
         Caption         =   "Zero"
         Height          =   252
         Index           =   3
         Left            =   120
         TabIndex        =   9
         Top             =   1680
         Width           =   1212
      End
      Begin VB.OptionButton obDebugData 
         Caption         =   "Sine Wave"
         Height          =   252
         Index           =   2
         Left            =   120
         TabIndex        =   8
         Top             =   1200
         Width           =   1212
      End
      Begin VB.OptionButton obDebugData 
         Caption         =   "Random"
         Height          =   252
         Index           =   1
         Left            =   120
         TabIndex        =   7
         Top             =   720
         Width           =   1212
      End
      Begin VB.OptionButton obDebugData 
         Caption         =   "Binary"
         Height          =   252
         Index           =   0
         Left            =   120
         TabIndex        =   6
         Top             =   240
         Width           =   1212
      End
   End
   Begin VB.TextBox tbDebugBoardType 
      Height          =   372
      Left            =   1080
      Locked          =   -1  'True
      TabIndex        =   3
      Top             =   360
      Width           =   492
   End
   Begin VB.VScrollBar vsDebugDataBoard 
      Height          =   492
      Left            =   600
      Max             =   1
      Min             =   6
      TabIndex        =   2
      Top             =   360
      Value           =   1
      Width           =   252
   End
   Begin VB.TextBox tbDebugDataBoard 
      Height          =   372
      Left            =   120
      TabIndex        =   1
      Top             =   360
      Width           =   372
   End
   Begin VB.Label Label1 
      Caption         =   "Board Type"
      Height          =   252
      Left            =   960
      TabIndex        =   4
      Top             =   120
      Width           =   972
   End
   Begin VB.Label lblDebugDataBoard 
      Caption         =   "Board Nbr"
      Height          =   252
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   852
   End
End
Attribute VB_Name = "frmDebugData"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim iBoard As Integer
Dim J As Integer
Dim I As Long
Dim fval As Double

Private Sub Form_Load()
   vsDebugDataBoard.value = 1
   vsDebugDataBoard_Change
End Sub

Private Sub obDebugData_Click(Index As Integer)
   Dim fval As Double
   Select Case Index
   Case 0:  ' Binary
      For I = 0 To MAX_SAMPLES - 1
         bDataArray(iBoard, I) = (I) Mod 256
      Next I
   Case 1:  ' Random
      For I = 0 To MAX_SAMPLES - 1
         J = Rnd * 256
         If J < 256 Then
            bDataArray(iBoard, I) = J
         Else
            I = I - 1
         End If
      Next I
   Case 2:  ' Sine wave
      For I = 0 To MAX_SAMPLES - 1
         fval = (I Mod 360) * 3.14159265358979 / 180 ' convert to radians
         fval = Sin(fval)
         fval = (fval + 1#) * 128#     ' normalize to 0..256
         J = fval                      ' convert to int
         If J = 256 Then J = 255
         bDataArray(iBoard, I) = J
      Next I
   Case 3:  ' zero
      For I = 0 To MAX_SAMPLES - 1
         bDataArray(iBoard, I) = 0
      Next I
   End Select
End Sub

Private Sub vsDebugDataBoard_Change()
   For I = 0 To 2
      obDebugData(I).value = False
   Next I
   iBoard = vsDebugDataBoard.value
   tbDebugDataBoard.Text = iBoard
   If iBoardType(iBoard) = LA_BOARD Then
      tbDebugBoardType.Text = "LA"
   End If
   If iBoardType(iBoard) = AD_BOARD Then
      tbDebugBoardType.Text = "A/D"
   End If
   If iBoardType(iBoard) = 0 Then
      tbDebugBoardType.Text = "  "
   End If
End Sub
